
#include "crc16.h"
#include "defs.h"

void outstr0(unsigned char);

unsigned int crc16_update(unsigned int crc, volatile unsigned char a)
{
  int i;
  outstr0(a);
  crc ^= a;
  for(i = 0; i < 8; ++i)
  {
    if(crc & 1)
      crc = (crc >> 1) ^ 0xA001;
    else
      crc = (crc >> 1);

  }
  return crc;
}


// CRC16 Checksumme
// Polynom: 8005
// Startwert: FFFF, direct
// reverse data bytes, reverse CRC result before Final XOR

// empfangenes Kommando steht in buf[], erstmal CRC16-Check
unsigned char crc16(volatile unsigned char *buf, unsigned char inout)
{
  unsigned char i, length; // c1, c2; // buffer[5];
  union crcbytes crc; // crc.all = 16 Byte = crc.lo + crc.hi

  crc.all = 0xFFFF;

  // hier ist das ganz groe Problem
  length = buf[1]; // buf[1] (Datenlnge) nach length kopieren
  outstr0(length); // auf UART0 ausgeben, am PC kukken, ob's richtig ist...
  outstr0(buf[1]); // beim 1. Mal war length immer 0, buf[1] = 3, was richtig wre

  if(inout == OUT) // OUT = Daten zum PC
  {
    // CRC16 berechnen
    if(length > MAXMSGLEN-2) // 2 byte reserved for CRC
      return 1;

    for(i = 0; i <= length; i++)
      crc.all = crc16_update(crc.all, buf[i]);

    buf[i+1] = crc.lo; // CRC anfuegen, lo-Teil
    buf[i]   = crc.hi; // CRC anfuegen, hi-Teil
    return 0;
  }
  else // inout = IN = Daten vom PC
  {
    outstr0(buf[0]);
    outstr0(buf[1]);
    outstr0(buf[2]);
    outstr0(buf[3]);
    outstr0(buf[4]);
    outstr0(length);
    // unsigned int _crc16_update(unsigned int __crc, unsigned char __data)
    for(i = 0; i < length; i++)
      crc.all = crc16_update(crc.all, buf[i]);

    if(crc.hi == buf[length]) // Gegencheck 1. Byte, CRC16Hi
    {
      if(crc.lo == buf[length+1]) // Gegencheck 2. Byte, CRC16Lo
        return 0; // CRC ok
      else
      {
			  outstr0(crc.hi);
			  outstr0(crc.lo);
        return 1;
			}
    }
    else
		{
		  outstr0(crc.hi);
			outstr0(crc.lo);
      return 1; // CRC-Fehler
		}
  }
}
