
#include "defs.h"

void InitVars(unsigned char plain);
void InitPeripherie(void); // Peripherie = Timer, USART, Ports, (ext. Interrupts)
void sleep8(unsigned char wait);
unsigned char crc16(volatile unsigned char *buf, unsigned char inout);

// neuen Offset berechnen  (bytecount = XLEN = 5)
// bytecount = bytecount + messages.allframes[bytecount] + 5; // alter Wert + XLEN + 6 Headerbytes-1
//   15      =    5      +               4               + 6
//   26          15      +               5               + 6
typedef unsigned char frames[91];
union messagestosend // 91 Byte
{
  frames allframes;
  struct
  {                                 // [0], [1] , [2], [3] , [4] , [5] , [6], [7], [8], [9], [10] ...
    unsigned char speed[10];        // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID,  d1,  CS
    unsigned char rpm[11];          // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID,  d1,  d2,  CS
    unsigned char aussentemp[11];   // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID, data, data
    unsigned char coolant[10];      // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID, data
    unsigned char ignition[10];     // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID, data ????
    unsigned char compfan[11];      // REP, PRIO, CYT, PCNT, CCNT, XLEN, MID, PID, data ????
    unsigned char free[28];         // REP, PRIO, CYT, PCNT, CCNT, XLEN, ???
  };
};

static volatile union messagestosend messages;


union Bitfield
{
  unsigned int allbits;
  struct
  {
    unsigned char _critical:1;    // 1 = kritischer Bereich wird gerade beschrieben
    unsigned char timeout:1;     // 1 = Timeout ist aufgetreten
    unsigned char _datasetnew:1;  // 1 = neue Daten vorhanden
    unsigned char datacrash:1;   // 1 = Datencrash auf dem J-Bus erkannt oder kein Datenempf.
    unsigned char timeouting:1;  // 1 = Timeout Funktionalitt ist aktiviert
    unsigned char uart0rcvoff:1; // 1 = UART0 Receiver ausgeschaltet
    unsigned char uart1overflow:1; // 1 = Empfangspuffer von UART1 (J-Bus) berschrieben
    unsigned char uart1rcv:1;		 // 1 = Daten im Empfangspuffer vorhandn (J-Bus)
    unsigned char receivemultiframe:1; // 1 = Multiframe wird gegenwrtig empfangen, "Framepause" akitv
    unsigned char unused2:1;
    unsigned char unused3:1;
    unsigned char unused4:1;
    unsigned char unused5:1;
    unsigned char unused6:1;
    unsigned char unused7:1;
    unsigned char unused8:1;
  };
};

static volatile union Bitfield flag;

union Timings
{
  unsigned int alltime;
  struct
  {
    unsigned char wait;         // Wartezeit Zhlvariable
    unsigned char maxwait;      // max. wartezeit
  };
};

static volatile union Timings timer;

typedef /*unsigned*/ char jbusall[JBUSMSG];

union jbusdataset // 50 Byte
{
  //unsigned char all[JBUSMSG];
  jbusall all;
  struct
  {
    /*unsigned*/ char indicatorlamp[4];
    /*unsigned*/ char aclamp[4];
    /*unsigned*/ char diagnosticdata[21];
    /*unsigned*/ char c2[21];
  };
};

static union jbusdataset jbusrcv;

